/********************************************************
** Fan-Controll                                        **
** Download from: http://wissensdurst.homeip.net/      **
********************************************************/

#include <AH_74HC595.h>
#include <OneWire.h>
#include <DallasTemperature.h>

#define ONE_WIRE_BUS 9
#define FAN_PIN 13

// Setup a oneWire instance to communicate with any OneWire devices
OneWire oneWire(ONE_WIRE_BUS);

// Pass our oneWire reference to Dallas Temperature. 
DallasTemperature sensors(&oneWire);

/*
#define SER_Pin   4   //Serial data input
#define RCLK_Pin  3   //Register clock
#define SRCLK_Pin 2   //Shift register clock
*/

DeviceAddress term1 = { 0x28, 0x2C, 0x79, 0x09, 0x04, 0x00, 0x00, 0x46 };
byte tempC, stelleX, sollTemp=23;
boolean fan_now=false;
boolean fan_old=false;

//Initialisation
//AH_74HC595 seven_segment1(SER_Pin, RCLK_Pin, SRCLK_Pin); 
AH_74HC595 seven_segment1(4, 3, 2, true); 
AH_74HC595 seven_segment2(8, 7, 6, true); 

void setup(){
  pinMode(FAN_PIN, OUTPUT);
  digitalWrite(FAN_PIN, LOW);
  seven_segment1.clear();
  seven_segment2.clear(); 

  sensors.begin();
  // set the resolution to 12 bit
  sensors.setResolution(term1, 12);
}

void loop(){
  // wait for the slow sensor
  delay(2000);
  
  // Request temperature
  sensors.requestTemperatures();
  // get the value
  tempC = sensors.getTempC(term1);
  if (tempC < -100) {
    // show the fail of the sensor
    seven_segment1.showNumber(15);
    seven_segment2.showNumber(15);
    // default turn the fans on
    fan_now = true;
  }else{
    // divide the value in two peaces and show them
    stelleX = tempC % 10;
    seven_segment1.showNumber(stelleX);
    stelleX = tempC / 10;
    seven_segment2.showNumber(stelleX);
    if ( tempC > sollTemp ) {
      // its hot, turn fans on
      fan_now = true;
    }else{
      // debounce jumping value
      if ( fan_now == true ) {
        if ( tempC > (sollTemp - 1) ) {
          fan_now = true;
        }else{
          fan_now = false;
        }
      }
    }
  }
  // do the action, if neccessary
  if ( fan_now != fan_old ) {
    digitalWrite(FAN_PIN, fan_now);
    fan_old = fan_now;
  }
}

